#ifndef __MODSETUP_H
#define __MODSETUP_H

#ifndef _WIN32
#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef WORD
#define WORD unsigned short
#endif

#ifndef SHORT
#define SHORT signed short
#endif

#ifndef DWORD
#define DWORD unsigned long
#endif
#else
#include <windows.h>
#endif

#define ITEM_CHKBOX 0x8000
#define ITEM_RADBOX 0x4000
#define ITEM_GRAYED 0x2000
#define ITEM_HILITE 0x1000

#define MENU_NFOBOX 0x8000
#define MENU_DLGBOX 0x4000
#define MENU_TYPMSK 0xC000
#define MENU_ITEMSK 0x3FFF

#define GetMenuData(x) ((x).flag & 0x0FFF)
#define SetMenuData(x,d) (x).flag = ((x).flag & 0xF000) | ((d) & 0x0FFF)
#define SET_LITE(m,s) (m).flag = (((m).flag | ITEM_HILITE) ^ ((s) ? 0 : ITEM_HILITE))
#define SET_GRAY(m,s) (m).flag = (((m).flag | ITEM_GRAYED) ^ ((s) ? 0 : ITEM_GRAYED))
#define ITS_LITE(m) ((m).flag & ITEM_HILITE)
#define ITS_GRAY(m) ((m).flag & ITEM_GRAYED)

#pragma pack(push, 1)
typedef struct {
  char *item;
  char *hint;
  WORD  flag;
} menuitem;
#pragma pack(pop)

typedef int (*PMENUPROC)(int);

void InitSetup(char *l, char *r);
void FreeSetup(void);
int DrawMenu(menuitem *items, PMENUPROC mp);
int DrawInfo(menuitem *item, PMENUPROC mp);
int DrawTest(menuitem *item, PMENUPROC mp);
void DefMenuItem(menuitem *menu, int item);

#endif
